/** cam.c **/

#include <eyebot.h>
#include <libimpro/improc.h>

/** picture to work on */
colimage img;

/** picture for LCD-output */
image greyimg, borderimg, umbimg ;

/** camera version */
int camera;
IPL_CONFIG _IPLConfig;

int initCamera(void);


/*************************************************************************/
/** Run program.
    Display and process camera picture until end-button is pressed. */
/*************************************************************************/

int main()
{
	BYTE th = 90;

	initCamera();

	LCDClear();
	LCDMode(SCROLLING|NOCURSOR);
	LCDMenu("","","","End");
  	while (KEYRead()!=KEY4)
  	{
       	CAMGetColFrame(&img,FALSE); 
      	IPColor2Grey(&img,&greyimg); 
		IPSobel(&greyimg, &borderimg);
		
		IPL_threshold((BYTE *)&borderimg, (BYTE *)&umbimg, th); 

   		LCDPutGraphic(&borderimg);  
  	}

	CAMRelease();
	return 0;
}



/* ********************************************************************* */
/* This routine initializes the Image Processing system, the camera,     */
/* IPL library,  the screen constants									 */
/* ********************************************************************* */
int initCamera(void)
{

	/* Initialize the Image Processing System */

	_IPLConfig.colorBlack = 0;
	_IPLConfig.colorWhite = 15;
	_IPLConfig.imageWidth = imagecolumns;
	_IPLConfig.imageHeight = imagerows;

	IPL_init(&_IPLConfig);  

	/* Initialize camera */
	camera=CAMInit(WIDE);
	if (camera==NOCAM)
    		OSError("No camera!\n", camera, FALSE);
	else if (camera==INITERROR)
      	OSError("CAMInit!\n", camera, FALSE);

	return(0);
}

